lots o fixes, beets, shellcheck stuff
[distro-setup] / switch-mail-host
index fd3d032cce84c34bec53d82b90f430f5bb0a0308..4e8dfdece189e4080966d72e18ed5e025bc93c18 100644 (file)
@@ -4,7 +4,7 @@ source /usr/local/lib/err
 
 usage() {
   cat <<EOF
-Usage: ${0##*/} [OPTIONS] push|pull HOST
+Usage: switch-mail-host|switch-host2 [OPTIONS] push|pull HOST
 
 Turn off mail receiving on OLD_HOST, run btrbk to move mail to NEW_HOST,
 turn on mail receiving on NEW_HOST.  Assumes we want to move all
@@ -41,7 +41,7 @@ err-cleanup() {
   fi
 }
 
-pre="$script_name:"
+pre="${SSH_CLIENT:+$HOSTNAME} $script_name:"
 m() { printf "$pre %s\n"  "$*"; "$@"; }
 e() { printf "$pre %s\n"  "$*"; }
 err() { echo "$pre ERROR: $*" >&2; }
@@ -92,8 +92,10 @@ case $direction in
     new_host=$host
     bbk_args="-t $new_host"
     new_shell="ssh -F $HOME/.ssh/confighome root@$new_host"
-    $new_shell -v hostname
-    new_hostname=$($new_shell hostname)
+    if ! new_hostname=$($new_shell hostname); then
+      echo "$pre: error: failed ssh. retrying failed $new_shell with -v for more info:"
+      $new_shell -v hostname
+    fi
     ;;
   pull)
     old_host=$host
@@ -101,6 +103,7 @@ case $direction in
     new_hostname=$HOSTNAME
     bbk_args="-s $old_host"
     old_shell="ssh -F $HOME/.ssh/confighome root@$old_host"
+    old_shelliank="ssh -F $HOME/.ssh/confighome iank@$old_host"
     # tests ssh connection. crafted this to not need to do escape chars
     f=/a/bin/bash_unpublished/source-state
     if ! old_info=($($old_shell "hostname; sed -n s,.*MAIL_HOST=,,p $f; sed -n s,.*HOST2=,,p $f")); then
@@ -132,7 +135,6 @@ case $script_name in
     ;;
 esac
 
-
 if $mail_only; then
   mp_args="-m /o"
 elif $host2_only; then
@@ -140,8 +142,12 @@ elif $host2_only; then
 fi
 
 
-
-if [[ $old_hostname != "$MAIL_HOST" ]] && ! $force; then
+if $host2_only; then
+  if [[ $old_hostname != "$HOST2" ]]; then
+    err "\$old_hostname($old_hostname) != \$HOST2($HOST2). Rerun with --force if you really want this."
+    exit 1
+  fi
+elif [[ $old_hostname != "$MAIL_HOST" ]] && ! $force; then
   err "\$old_hostname($old_hostname) != \$MAIL_HOST($MAIL_HOST). Rerun with --force if you really want this."
   exit 1
 fi
@@ -190,8 +196,7 @@ e "On $new_host: umounting /m and /o, checking emacs"
   cat <<'EOF'
 set -eE
 if pgrep -G iank -u iank -f 'emacs --daemon' &>/dev/null; then
-  export XDG_RUNTIME_DIR=/run/user/1000
-  bufs="$(emacsclient --eval "$(cat /a/bin/ds/unsaved-buffers.el)"| sed '/^"nil"$/d;s/^"(/E: /;s/)"$//')"
+  bufs="$(sudo -u iank env XDG_RUNTIME_DIR=/run/user/1000 emacsclient --eval "$(cat /a/bin/ds/unsaved-buffers.el)"| sed '/^"nil"$/d;s/^"(/E: /;s/)"$//')"
   if [[ $bufs ]]; then
     echo "error: on $HOSTNAME, unsaved emacs files: $bufs" >&2
     exit 1
@@ -212,8 +217,7 @@ EOF
 
 $old_shell bash -s <<'EOF'
 if pgrep -G iank -u iank -f 'emacs --daemon' &>/dev/null; then
-  export XDG_RUNTIME_DIR=/run/user/1000
-  bufs="$(emacsclient --eval "$(cat /a/bin/ds/unsaved-buffers.el)"| sed '/^"nil"$/d;s/^"(/E: /;s/)"$//')"
+  bufs="$(sudo -u iank env XDG_RUNTIME_DIR=/run/user/1000 emacsclient --eval "$(cat /a/bin/ds/unsaved-buffers.el)"| sed '/^"nil"$/d;s/^"(/E: /;s/)"$//')"
   if [[ $bufs ]]; then
     echo "error: on $HOSTNAME, unsaved emacs files: $bufs" >&2
     exit 1
@@ -249,6 +253,10 @@ if ! $mail_only; then
 fi
 
 if $host2_only; then
+  if [[ $old_hostname != "$MAIL_HOST" && $old_hostname != kd ]]; then
+    m $old_shell systemctl --now disable btrbk.timer
+  fi
+  m $new_shell systemctl --now enable btrbk.timer
   exit 0
 fi
 
@@ -263,7 +271,7 @@ fi
 m $new_shell killall -q emacs ||:
 
 e Running main btrbk
-m btrbk-run -v $bbk_args $incremental_arg -m /o || ret=$?
+m btrbk-run -v --fast $bbk_args $incremental_arg -m /o || ret=$?
 if (( ret )); then
   bang="$(printf "$(tput setaf 5)█$(tput sgr0)%.0s" 1 2 3 4 5 6 7)"
   e $bang failed btrbk of /o. restoring old host as primary
@@ -271,6 +279,10 @@ if (( ret )); then
   exit $ret
 fi
 
+# new system is usable at this point
+printf "$(tput setaf 5 2>/dev/null ||:)█$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
+echo
+
 # once I accidentally accepted incoming mail on old host. I used this script to copy over that mail:
 #
 # die=false; for d in o.leaf.2021-05-29T10:02:08-0400/m/{4e,md,4e2}/{,l/}!(*myarchive)/new; do if $die; then break; fi; find $d -type f -mtime -5 | while read -r f; do dir="${f%new/*}"; dir="btrbk/o.20210530T000011-0400/${dir#*/}"; fname="${f##*/}"; [[ -e $dir/new/$fname || -e $dir/cur/$fname ]] && continue; if ! e cp -a $f /${dir#*/*/}new; then echo failed cp; die=true; break; fi ; done; done